unit hiImg_Rotate;
interface
uses Windows, Kol,Share,Debug;
type
  THIImg_Rotate = class(TDebug)
   private
    FDataWidth:TData;
    FDataHeight:TData;
    cosA:Real;
    sinA:Real;
    procedure setFData(W:Integer; H:Integer);
    function Point(x:Integer; y:Integer): TPoint;
//    function yComp(Vektor: TPoint): Integer;
    function RotImage(scr:PBitmap; angle:Extended; Color:TColor): PBitmap;
   public
    _prop_angle:real;
    _prop_BackgroundColor:integer;
    _data_Bitmap:THI_Event;
    _data_angle:THI_Event;
    _data_BackgroundColor:THI_Event;
    _event_onResult:THI_Event;
    procedure _work_doRotate(var _Data:TData; Index:word);
    procedure _work_doFlipVertical(var _Data:TData; Index:word);
    procedure _work_doFlipHorizontal(var _Data:TData; Index:word);
    procedure _var_Width(var _Data:TData; Index:word);
    procedure _var_Height(var _Data:TData; Index:word);
  end;
implementation

procedure THIImg_Rotate._var_Width;
begin
   _Data := FDataWidth;
end;

procedure THIImg_Rotate._var_Height;
begin
   _Data := FDataHeight;
end;
//==================================================
procedure THIImg_Rotate.setFData(W:Integer; H:Integer);
begin
    FDataWidth.Data_type := data_int;
    FDataWidth.idata := Round(W);
    FDataHeight.Data_type := data_int;
    FDataHeight.idata := Round(H);
end;

function THIImg_Rotate.Point(x:Integer; y:Integer): TPoint;
begin 
	Result.x := x; 
	Result.y := y; 
end;

{function THIImg_Rotate.yComp(Vektor: TPoint): Integer;
begin 
	Result := Round(Vektor.x * sinA + Vektor.y * cosA); 
end; 
}
function THIImg_Rotate.RotImage(scr:PBitmap; angle:Extended; Color:TColor): PBitmap;
var	res: PBitmap;
		highest, lowest, mostleft, mostright: TPoint; 
		topoverh, leftoverh: integer; 
		x, y, H, W, newx, newy: integer;
		r: TRect;
begin
	H := scr.Height;
	W := scr.Width; 
	if (angle <= (pi / 2)) then
	begin 
		highest := Point(0,0);
		lowest := Point(W,H);
		mostleft := Point(0,H);
		mostright := Point(W,0);
	end 
	else if (angle <= pi) then
	begin 
		highest := Point(0,H); 
		lowest := Point(W,0); 
		mostleft := Point(W,H); 
		mostright := Point(0,0); 
	end 
	else if (angle <= (pi * 3 / 2)) then
	begin 
		highest := Point(W,H); 
		lowest := Point(0,0); 
		mostleft := Point(W, 0); 
		mostright := Point(0,H); 
	end 
	else 
	begin 
		highest := Point(W, 0); 
		lowest := Point(0,H); 
		mostleft := Point(0,0); 
		mostright := Point(W,H); 
	end;
	cosA := cos(angle);
	sinA := sin(angle);
	topoverh := Round(highest.x * sinA + highest.y * cosA); 
	leftoverh := Round(mostleft.x * cosA - mostleft.y * sinA); 
	y := Abs(Round(lowest.x * sinA + lowest.y * cosA)) + Abs(topoverh); 
	x := Abs(Round(mostright.x * cosA - mostright.y * sinA)) + Abs(leftoverh);
	res := NewBitmap(x,y);
	res.PixelFormat := pf24bit;
	res.Width := x;
	res.Height := y; 
	res.Canvas.Brush.Color := Color;
	r.Top := 0;
	r.Left := 0;
	r.Right := x;
	r.Bottom := y;
  res.Canvas.FillRect(r);
if (angle < (pi / 2)) or ((angle > pi) and (angle < (pi * 3 / 2))) then
begin	
	for y := 0 to H - 1 do 
	begin
		for x := 0 to W - 1 do 
		begin
			newX := Round(x * cosA - y * sinA) - leftoverh; 
			newY := Round(x * sinA + y * cosA) - topoverh;   
			res.Canvas.Pixels[newx, newy] := scr.Canvas.Pixels[x, y];   
			res.Canvas.Pixels[newx, newy + 1] := scr.Canvas.Pixels[x, y]; 
		end;
	end;
	end
else
begin
	for y := 0 to H - 1 do 
	begin
		for x := 0 to W - 1 do 
		begin
			newX := Round(x * cosA - y * sinA) - leftoverh; 
			newY := Round(x * sinA + y * cosA) - topoverh; 
			res.Canvas.Pixels[newx, newy] := scr.Canvas.Pixels[x, y];   
			res.Canvas.Pixels[newx + 1,newy] := scr.Canvas.Pixels[x, y]; 
		end;		
	end;
end;				
	Result := res;	 
	end;
//==================================================
procedure THIImg_Rotate._work_doRotate;
type TLine = array[0..0]of byte;
     PTLine = ^TLine;
var  VArray: array of PTLine;
     X,Y,W,H,i,j,color:integer;
     bmp,scr1,scr2:PBitmap;
     Sor,Dest:PTLine;
     dt:TData;
     angle:real;
begin
  bmp := ReadBitmap(_Data,_data_Bitmap,nil);
  if bmp <> nil then
   begin
    W := bmp.Width;
    H := bmp.Height;
    _Data.Data_type := 0;
    angle := ReadReal(_Data,_data_angle,_prop_angle);
    color := ReadInteger(_Data,_data_BackgroundColor,_prop_BackgroundColor);
    while angle > 360 do angle := angle - 360;
    while angle < 0 do angle := angle + 360;
    case Trunc(angle) of
      0,360: begin
        scr2 := NewBitmap(W,H);
        scr2.PixelFormat := pf24bit;
        scr2.Assign(bmp);
        setFData(scr2.Width, scr2.Height);
        dt.data_type := data_bitmap;
        dt.idata := integer(scr2);
        _hi_OnEvent(_event_onResult,dt);
        scr2.Free;
      end;
      90,270: begin
        scr1 := NewBitmap(0,0);
        scr1.Assign(bmp);
        scr1.PixelFormat := pf24bit;
        scr2 := NewBitmap(H,W);
        scr2.PixelFormat := pf24bit;
        SetLength(VArray,H);
        x := 0;
        y := 0;
        if angle = 90.0 then x := H-1
                        else y := W-1;
        for i := 0 to H-1 do begin
	   Sor := scr1.ScanLine[Abs(x - i)];
	   VArray[i] := Sor
	   end;
        for i:=0 to W-1 do begin
          Dest := scr2.ScanLine[i];
          for j := 0 to H-1 do begin
              x := Abs(y - i)*3;
              Sor := VArray[j];
              Dest[0] := Sor[x];
              Inc(Dest);
              Dest[0] := Sor[x+1];
              Inc(Dest); 
              Dest[0] := Sor[x+2];
              Inc(Dest);
          end;
        end;
        setFData(scr2.Width, scr2.Height);
        dt.data_type := data_bitmap;
        dt.idata := integer(scr2);
        _hi_OnEvent(_event_onResult,dt);
        scr1.Free;
        scr2.Free;
      end;
      180: begin
        scr1 := NewBitmap(0,0);
        scr1.Assign(bmp);
        scr1.PixelFormat := pf24bit;
        scr2 := NewBitmap(W,H);
        scr2.PixelFormat := pf24bit;
        for I:=0 to H-1 do begin
          Sor := scr1.ScanLine[i];
          Dest := scr2.ScanLine[H-1-i];
          for j := 0 to W-1 do begin
              Dest[(W-1-j)*3 + 0] := Sor[j*3+0]; //R
              Dest[(W-1-j)*3 + 1] := Sor[j*3+1]; //G
              Dest[(W-1-j)*3 + 2] := Sor[j*3+2]; //B
          end;
        end;
        setFData(scr2.Width, scr2.Height);
        dt.data_type := data_bitmap;
        dt.idata := integer(scr2);
        _hi_OnEvent(_event_onResult,dt);
        scr1.Free;
        scr2.Free;
      end;
      else begin
        scr1 := NewBitmap(W,H);
        scr1.Assign(bmp);
        scr1.PixelFormat := pf24bit;
        angle:=angle*Pi/180;
begin		
		scr2:=RotImage(scr1, angle, Color);
		setFData(scr2.Width, scr2.Height);		
		dt.data_type := data_bitmap;
		dt.idata := integer(scr2);
		_hi_OnEvent(_event_onResult,dt);
		scr1.Free;
		scr2.Free;
end;
      end;
    end;
   end;
end;

procedure THIImg_Rotate._work_doFlipVertical;
type TLine = array[0..0]of byte;
var
   W,H,i,j:integer;
   bmp,scr1,scr2:PBitmap;
   Sor,Dest:^TLine;
   dt:TData;
   r,g,b:smallint;
   st:real;
begin
  bmp := ReadBitmap(_Data,_data_Bitmap,nil);
  if bmp <> nil then
   begin
    W := bmp.Width;
    H := bmp.Height;
    _Data.Data_type := 0;
    st := ReadReal(_Data,_data_angle,_prop_angle);
    scr1 := NewBitmap(0,0);
    scr1.Assign(bmp);
    scr1.PixelFormat := pf24bit;
    scr2 := NewBitmap(W,H);
    scr2.PixelFormat := pf24bit;
    for I:=0 to H-1 do begin
      Sor := scr1.ScanLine[i];
      Dest := scr2.ScanLine[H-1-i];
      for j := 0 to W-1 do begin
          Dest[j*3+0] := Sor[j*3+0]; //R
          Dest[j*3+1] := Sor[j*3+1]; //G
          Dest[j*3+2] := Sor[j*3+2]; //B
      end;
    end;
    setFData(scr2.Width, scr2.Height);
    dt.data_type := data_bitmap;
    dt.idata := integer(scr2);
    _hi_OnEvent(_event_onResult,dt);
    scr1.Free;
    scr2.Free;
   end;
end;

procedure THIImg_Rotate._work_doFlipHorizontal;
type TLine = array[0..0]of byte;
var
   W,H,i,j:integer;
   bmp,scr1,scr2:PBitmap;
   Sor,Dest:^TLine;
   dt:TData;
   r,g,b:smallint;
   st:real;
begin
  bmp := ReadBitmap(_Data,_data_Bitmap,nil);
  if bmp <> nil then
   begin
    W := bmp.Width;
    H := bmp.Height;
    _Data.Data_type := 0;
    st := ReadReal(_Data,_data_angle,_prop_angle);
    scr1 := NewBitmap(0,0);
    scr1.Assign(bmp);
    scr1.PixelFormat := pf24bit;
    scr2 := NewBitmap(W,H);
    scr2.PixelFormat := pf24bit;
    for i := 0 to H-1 do begin
      Sor := scr1.ScanLine[i];
      Dest := scr2.ScanLine[i];
      for j := 0 to W-1 do begin
          Dest^[(W-1-j)*3 + 0] := Sor^[j*3+0]; //R
          Dest^[(W-1-j)*3 + 1] := Sor^[j*3+1]; //G
          Dest^[(W-1-j)*3 + 2] := Sor^[j*3+2]; //B
      end;
    end;
    setFData(scr2.Width, scr2.Height);
    dt.data_type := data_bitmap;
    dt.idata := integer(scr2);
    _hi_OnEvent(_event_onResult,dt);
    scr1.Free;
    scr2.Free;
   end;
end;
end.
